#!/usr/bin/env python3

import argparse
import itertools
import json
import matplotlib.pyplot as plt
import numpy as np
import random
import sys
import time
import tqdm 

from PIL import Image, ImageDraw

def draw(detours, files_requested, tape, right, name,path):
    
    
    
    padding = 10
    time_scale = 0.5
    

    remaining = [0 for i in tape]
    for f in range(len(files_requested)):
        remaining[files_requested[f]] = 1    
        
        
    last_pos = len(tape)-1
    time = 0
    for (a,b) in detours:
        for i in range(files_requested[a],files_requested[b]+1):
            remaining[i] = 0
            
    last = files_requested.index(np.max(np.nonzero(remaining)))
    detours.append( (0, last))
    
    
    if right[-1] > 5000:
        scale = 5000./right[-1]
        right = [int(scale*x) for x in right]
    
    height = int(time_scale*(sum([right[files_requested[b]]-right[files_requested[a]-1] for (a,b) in detours])*2 + right[-1] - right[files_requested[last]] + right[files_requested[0]-1] +10))
    
    if height>5000:
        time_scale *= 5000./height
        height=5000
    
    im = Image.new('RGB', (right[-1], height), (128, 128, 128))
    draw = ImageDraw.Draw(im)

    for f in files_requested:
        draw.rectangle((right[f-1], 0, right[f], height), fill=(204, 204, 255), outline=(0,0,0))
    
    for (a,b) in detours:
        draw.line((right[last_pos], int(time_scale*time), right[files_requested[a]-1], int(time_scale*(time+right[last_pos]-right[files_requested[a]-1])), right[files_requested[b]], int(time_scale*(time + right[last_pos]-2*right[files_requested[a]-1]+right[files_requested[b]]))), fill=(255, 0, 0), width=2)
        time += right[last_pos]-2*right[files_requested[a]-1]+right[files_requested[b]]
        last_pos = files_requested[b]
    

    im.save(path+'/'+name + '.png', quality=95)

